#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define NMAX 500
#define MMAX 500

void ev(int n, int m, int *(*NE), int *(*E), int COUNT, double *EV);


int main(int argc, char *argv[]) { 
 
  int n = 0, m = 0, I[MMAX][NMAX];
  int i, j, k, count;
  int *(*NE);
  int *(*E);
  double *(*EV);
  double p = 0.5;
  int N = 15;
  int COUNT = 10000;
  double s;
  double sum1, sum2;
  double smin = 0.05;
  double v, a;
  double *ans;
  double *vans;
  int F = 3;
  int flag = 0;

   /* ץΥå */
  if (argc <= 2 ) flag = 0; /* ץʤ */
  if (argc >= 2 && strcmp(argv[1], "-h") == 0) {
    printf("evcalc --- calculate uniform expected rank of a connected graph\n");
    printf("Usage: ");
    printf("evcalc [option] < datafile\n");
    printf("option: \n");
    printf(" -h ... show this help \n");
    printf(" -n n ... set number of trials to be n \n");
    printf(" -s x ... set the (target) bound of standard deviation \n");
    printf(" -f n ... set the significant digits to be n \n");
    exit(0);
    }
  if (argc >= 2 && strcmp(argv[1], "-n") == 0) {
    COUNT = atoi(argv[2]);
    flag = 1;
    }
  if (argc >= 2 && strcmp(argv[1], "-s") == 0) {
    smin = atof(argv[2]); /*ɸкɸͤͿ줿硣*/
    flag = 2;
    }
  if (argc >= 2 && strcmp(argv[1], "-f") == 0) {
    F = atoi(argv[2]);  /* ͭͿϡF񤭤롣*/
    flag = 0;
    }


   /* եǡ */
   /* ޤ1Ԥ˽񤫤Ƥnm */
   scanf("%d", &m);
   scanf("%d", &n);

   /* mnincidence matrix */
   for (i = 0; i < m; i ++) {
    for (j = 0; j < n; j ++) {
     scanf("%d", &I[i][j]);
        }
      }

    /* ɤ߹ϤƤߤ */
    for (i = 0; i < m; i ++) {
      for (j = 0; j < n; j ++) {
        printf("%d ", I[i][j]);
      }
      printf("\n");
    }
    printf("\n");


    /* õΤŪѿ */
    /* ĺ٤ˤդꥹȤ 
       NE[v][k]v³kܤֹ */
    /* NE[i][0]ˤ³տ뤳Ȥˤ롣ͤ0 */
    NE = calloc(n, sizeof(int*));
    for (i = 0; i < n; i ++) {
      count = 0;
      for (j = 0; j < m; j ++)
        if (I[j][i] == 1) count ++;
      NE[i] = (int*)calloc(count, sizeof(int));
      NE[i][0] = count;
      }
    E = malloc(sizeof(int*) * m);
    for (i = 0; i < m; i ++) 
      E[i] = (int*)calloc(2, sizeof(int));

    for (i = 0; i < n; i ++) {
      count = 1;
      for (j = 0; j < m; j ++) {
        /* jĺi³Ƥڥ(j,i)򸫤Ĥ顢*/
        if (I[j][i] == 1) {
          NE[i][count++] = j;  /* ĺij³ƤϿ */
          for (k = 0; k < n; k ++) {
            /* j³⤦Ĥĺkõ*/
            if (k != i && I[j][k] == 1) {
              if (i < k) {
                E[j][0] = i; E[j][1] = k;
                } /* E[j][]jξüikϿ */
            }
          }
        }
      }
    }

  /* ׻ѤѰ */
  EV= calloc(N, sizeof(int*));
  for (i = 0; i < N; i ++)
    EV[i] = calloc(n, sizeof(double));
  ans= calloc(n, sizeof(double));
  vans= calloc(n, sizeof(double));

  /* ׻Υᥤʬ */
  if (flag == 0 || flag == 2) {
    while(1) {
      for (i = 0; i < N; i ++) 
        ev(n, m, NE, E, COUNT, EV[i]);
      v = 0.0; a = 0.0; /* vʬκǾ, aϷ׻ͤκǾͤõ */
      for (j = 0; j < n; j ++) {
        sum1 = 0.0; sum2 = 0.0;
        for (i = 0; i < N; i ++) {
          sum1 += EV[i][j];
          sum2 += EV[i][j] * EV[i][j];
          }
        ans[j] = sum1 / N;
        vans[j] = sum2/N - ans[j] * ans[j];
        if (v < vans[j]) v = vans[j];
        if (a < ans[j]) a = ans[j];
        }
      printf("min value = %f \n", a);
      if (flag == 0)
        smin = pow(10, (int)(log10(a))) * pow(0.1, (F-1)) / 2.0; /* ͭF */
      printf("smin = %f \n", smin);
      printf("v = %f \n", v);
      s = sqrt(v);  /* sɸк */
      printf("s = %f \n", s);
      if (s < smin) break;
      COUNT = COUNT * ( v / (smin * smin) ) * 2;
      printf("s = %f, COUNT = %d \n", s, COUNT);
      }
    }
  else if (flag == 1) { /* ֤COUNTץgivenξ */
      for (i = 0; i < N; i ++)
        ev(n, m, NE, E, COUNT, EV[i]);
      v = 0.0; a = 0.0; /* vʬκǾ, aϷ׻ͤκǾͤõ */
      for (j = 0; j < n; j ++) {
        sum1 = 0.0; sum2 = 0.0;
        for (i = 0; i < N; i ++) {
          sum1 += EV[i][j];
          sum2 += EV[i][j] * EV[i][j];
          }
        ans[j] = sum1 / N;
        vans[j] = sum2/N - ans[j] * ans[j];
        if (v < vans[j]) v = vans[j];
        if (a < ans[j]) a = ans[j];
        }
      printf("min value = %f \n", a);
      printf("smin = %f \n", smin);
      printf("v = %f \n", v);
      s = sqrt(v);  /* sɸк */
      printf("s = %f \n", s);
    }
  else {
    printf("error\n");
    exit(0);
    }

  for (i = 0; i < n; i ++)
    printf("%d: %f ( %f ) \n", i, ans[i], sqrt(vans[i]));
  printf("[ COUNT = %d, sigma = %f, N = %d ]\n", COUNT, s, N);

}

